* builtins.c (std_gimplify_va_arg_expr): Fix borked BIT_AND_EXPR.
[official-gcc.git] / maintainer-scripts / gcc_release
blob5a1d5d5ccdffd060da0119c419c7bbb306fb1c9a
1 #! /bin/sh
3 ########################################################################
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
9 # Contents:
10 # Script to create a GCC release.
12 # Copyright (c) 2001, 2002 Free Software Foundation.
14 # This file is part of GCC.
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
31 ########################################################################
33 ########################################################################
34 # Notes
35 ########################################################################
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
40 # gcc_release -r 3.0.2
42 # This script will automatically use the head of the release branch
43 # to generate the release.
45 ########################################################################
46 # Functions
47 ########################################################################
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
57 # Issue the informational message given by $1.
59 inform() {
60 echo "gcc_release: $1"
63 # Issue a usage message explaining how to use this script.
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
70 Options:
72 -r release Version of the form X.Y or X.Y.Z.
73 -s name:cvsbranch Create a snapshot, not a real release.
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
82 EOF
83 exit 1
86 # Change to the directory given by $1.
88 changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
97 adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
106 build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${CVSBRANCH} gcc || \
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then
129 cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE} Release Manager
132 * GCC ${RELEASE} released.
135 mv ${x}.new ${x} || \
136 error "Could not update ${x}"
137 (changedir `dirname ${x}` && \
138 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139 error "Could not commit ${x}"
141 done
143 # Update `gcc/version.c'.
144 for x in gcc/version.c; do
145 y=`basename ${x}`
146 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147 sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148 mv ${y}.new ${y} && \
149 ${CVS} ci -m 'Update version' ${y}) || \
150 error "Could not update ${x}"
151 done
153 # Make sure we tag the sources for a final release.
154 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
156 rm -rf ${SOURCE_DIRECTORY}
159 # Tag the sources.
160 EXPORTDATE=""
161 if [ -n "${TAG}" ]; then
162 inform "Tagging sources as ${TAG}"
163 # The -F option to CVS is intentionally not used below. If you
164 # need to retry a release, you will have to manually remove any
165 # existing tag.
166 ${CVS} rtag -r ${CVSBRANCH} ${TAG} gcc || \
167 error "Could not tag sources"
168 EXPORTTAG="-r${TAG}"
169 else
170 if [ ${CVSBRANCH} != "HEAD" ]; then
171 EXPORTTAG="-r${CVSBRANCH}"
172 # It does not work to use both "-r" and "-D" with
173 # "cvs export" so EXPORTDATE is not set here.
174 else
175 # HEAD is the default branch, no need to specify it.
176 EXPORTTAG=""
177 EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
181 # Export the current sources.
182 inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
184 if [ -z "${EXPORTTAG}" ]; then
185 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
186 "${EXPORTDATE}" gcc || \
187 error "Could not retrieve sources"
188 elif [ -z "${EXPORTDATE}" ]; then
189 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
190 "${EXPORTTAG}" gcc || \
191 error "Could not retrieve sources"
192 else
193 error "Cannot specify -r and -D at the same time"
196 # Run gcc_update on them to set up the timestamps nicely, and (re)write
197 # the LAST_UPDATED file containing the CVS tag/date used.
198 changedir "gcc-${RELEASE}"
199 contrib/gcc_update --touch
200 echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
202 # Obtain some documentation files from the wwwdocs module.
203 inform "Retrieving HTML documentation"
204 changedir "${WORKING_DIRECTORY}"
205 for x in bugs faq; do
206 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
207 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
208 ${SOURCE_DIRECTORY}) || \
209 error "Could not retrieve ${x}.html"
210 done
212 inform "Generating plain-text documentation from HTML"
213 changedir "${SOURCE_DIRECTORY}"
214 for file in *.html; do
215 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
216 (${ENV} TERM=vt100 lynx -dump $file \
217 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
218 > $newfile) || \
219 error "Could not generate text-only version of ${file}"
220 done
222 # For a prerelease or real release, we need to generate additional
223 # files not present in CVS.
224 changedir "${SOURCE_DIRECTORY}"
225 if [ $SNAPSHOT -ne 1 ]; then
226 # Generate the documentation.
227 inform "Building install docs"
228 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
229 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
230 export SOURCEDIR
231 export DESTDIR
232 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
234 # Regenerate the NEWS file.
235 contrib/gennews > NEWS || \
236 error "Could not regenerate NEWS files"
238 # Now, we must build the compiler in order to create any generated
239 # files that are supposed to go in the source directory. This is
240 # also a good sanity check to make sure that the release builds
241 # on at least one platform.
242 inform "Building compiler"
243 OBJECT_DIRECTORY=../objdir
244 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} \
245 -c "--enable-generated-files-in-srcdir" build || \
246 error "Could not rebuild GCC"
249 # Move message catalogs to source directory.
250 mv ../objdir/gcc/po/*.gmo gcc/po/
251 [ -f libcpp/po/cpplib.pot ] && mv ../objdir/libcpp/po/*.gmo libcpp/po/
253 # Create a "MD5SUMS" file to use for checking the validity of the release.
254 find . -type f |sed -e 's:^\./::' -e '/MD5SUMS/d' |sort |xargs md5sum >MD5SUMS
257 # Buid a single tarfile. The first argument is the name of the name
258 # of the tarfile to build, without any suffixes. They will be added
259 # automatically. The rest of the arguments are the files or
260 # directories to include, and possibly other arguments to tar.
262 build_tarfile() {
263 # Get the name of the destination tar file.
264 TARFILE="$1.tar.bz2"
265 shift
267 # Build the tar file itself.
268 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
269 error "Could not build tarfile"
270 FILE_LIST="${FILE_LIST} ${TARFILE}"
273 # Build a single tarfile if any of the directories listed exist,
274 # but not if none of them do (because that component doesn't exist
275 # on this branch).
276 maybe_build_tarfile() {
277 dest=$1
278 shift
279 dir_exists=0
280 for maybe_dir in "$@"; do
281 if [ -d "$maybe_dir" ]; then
282 dir_exists=1
284 done
285 if [ $dir_exists = 1 ]; then
286 build_tarfile "$dest" "$@"
287 else
288 echo "Not building $dest tarfile"
292 # Build the various tar files for the release.
294 build_tarfiles() {
295 inform "Building tarfiles"
297 changedir "${WORKING_DIRECTORY}"
299 # The GNU Coding Standards specify that all files should
300 # world readable.
301 chmod -R a+r ${SOURCE_DIRECTORY}
302 # And that all directories have mode 777.
303 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
305 # Build one huge tarfile for the entire distribution.
306 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
308 # Now, build one for each of the languages.
309 maybe_build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
310 maybe_build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
311 maybe_build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
312 maybe_build_tarfile gcc-fortran-${RELEASE} ${FORTRAN95_DIRS}
313 maybe_build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
314 maybe_build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
315 maybe_build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
317 # The core is everything else.
318 EXCLUDES=""
319 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} ${FORTRAN95_DIRS}\
320 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
321 EXCLUDES="${EXCLUDES} --exclude $x"
322 done
323 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
324 `basename ${SOURCE_DIRECTORY}`
327 # Build .gz files.
328 build_gzip() {
329 for f in ${FILE_LIST}; do
330 target=${f%.bz2}.gz
331 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
332 done
335 # Build diffs against an old release.
336 build_diffs() {
337 old_dir=${1%/*}
338 old_file=${1##*/}
339 old_vers=${old_file%.tar.bz2}
340 old_vers=${old_vers#gcc-}
341 inform "Building diffs against version $old_vers"
342 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-fortran gcc-java gcc-objc gcc-testsuite gcc-core; do
343 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
344 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
345 if [ ! -e $old_tar ]; then
346 inform "$old_tar not found; not generating diff file"
347 elif [ ! -e $new_tar ]; then
348 inform "$new_tar not found; not generating diff file"
349 else
350 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
351 ${f}-${old_vers}-${RELEASE}.diff.bz2
353 done
356 # Build an individual diff.
357 build_diff() {
358 changedir "${WORKING_DIRECTORY}"
359 tmpdir=gccdiff.$$
360 mkdir $tmpdir || error "Could not create directory $tmpdir"
361 changedir $tmpdir
362 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
363 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
364 ${DIFF} $2 $4 > ../${5%.bz2}
365 if [ $? -eq 2 ]; then
366 error "Trouble making diffs from $1 to $3"
368 ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
369 changedir ..
370 rm -rf $tmpdir
371 FILE_LIST="${FILE_LIST} $5"
374 # Upload the files to the FTP server.
375 upload_files() {
376 inform "Uploading files"
378 changedir "${WORKING_DIRECTORY}"
380 # Make sure the directory exists on the server.
381 if [ $LOCAL -eq 0 ]; then
382 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
383 mkdir -p "${FTP_PATH}/diffs"
384 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
385 else
386 mkdir -p "${FTP_PATH}/diffs" \
387 || error "Could not create \`${FTP_PATH}'"
388 UPLOAD_PATH=${FTP_PATH}
391 # Then copy files to their respective (sub)directories.
392 for x in gcc*.gz gcc*.bz2; do
393 if [ -e ${x} ]; then
394 # Make sure the file will be readable on the server.
395 chmod a+r ${x}
396 # Copy it.
397 case ${x} in
398 *.diff.*)
399 SUBDIR="diffs/";
402 SUBDIR="";
403 esac
404 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
405 || error "Could not upload ${x}"
407 done
410 # Announce a snapshot, both on the web and via mail.
411 announce_snapshot() {
412 inform "Updating links and READMEs on the FTP server"
414 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
415 changedir "${SNAPSHOTS_DIR}"
416 sed -e "s%@DATE@%$DATE%g" \
417 -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
418 -e "s%@LAST_DATE@%$LAST_DATE%g" \
419 -e "s%@BRANCH@%${BRANCH}%g" \
420 -e "s%@RELEASE@%${RELEASE}%g" \
421 -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
422 ~/scripts/snapshot-README > $$
423 mv $$ ${RELEASE}/README
424 sed -e "s%@DATE@%$DATE%g" \
425 -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
426 -e "s%@LAST_DATE@%$LAST_DATE%g" \
427 -e "s%@BRANCH@%${BRANCH}%g" \
428 -e "s%@RELEASE@%${RELEASE}%g" \
429 -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
430 ~/scripts/snapshot-index.html > $$
431 mv $$ ${RELEASE}/index.html
433 touch LATEST-IS-${BRANCH}-${DATE}
434 rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
436 inform "Sending mail"
438 export QMAILHOST=gcc.gnu.org
439 mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ${SNAPSHOTS_DIR}/${RELEASE}/README
442 ########################################################################
443 # Initialization
444 ########################################################################
446 # Today's date.
447 DATE=`date "+%Y%m%d"`
448 LONG_DATE=`date "+%Y-%m-%d"`
450 # The CVS server containing the GCC repository.
451 CVS_SERVER="gcc.gnu.org"
452 # The path to the repository on that server.
453 CVS_REPOSITORY="/cvs/gcc"
454 # The CVS protocol to use.
455 CVS_PROTOCOL="ext"
456 # The username to use when connecting to the server.
457 CVS_USERNAME="${USER}"
459 # The machine to which files will be uploaded.
460 GCC_HOSTNAME="gcc.gnu.org"
461 # The name of the account on the machine to which files are uploaded.
462 GCC_USERNAME="gccadmin"
463 # The directory in which the files will be placed (do not use ~user syntax).
464 FTP_PATH=/var/ftp/pub/gcc
465 # The directory in which snapshots will be placed.
466 SNAPSHOTS_DIR=${FTP_PATH}/snapshots
468 # The major number for the release. For release `3.0.2' this would be
469 # `3'
470 RELEASE_MAJOR=""
471 # The minor number for the release. For release `3.0.2' this would be
472 # `0'.
473 RELEASE_MINOR=""
474 # The revision number for the release. For release `3.0.2' this would
475 # be `2'.
476 RELEASE_REVISION=""
477 # The complete name of the release.
478 RELEASE=""
480 # The name of the branch from which the release should be made, in a
481 # user-friendly form.
482 BRANCH=""
484 # The name of the branch from which the release should be made, as used
485 # for our version control system.
486 CVSBRANCH=""
488 # The tag to apply to the sources used for the release.
489 TAG=""
491 # The old tarballs from which to generate diffs.
492 OLD_TARS=""
494 # The directory that will be used to construct the release. The
495 # release itself will be placed in a subdirectory of this diretory.
496 DESTINATION=${HOME}
497 # The subdirectory.
498 WORKING_DIRECTORY=""
499 # The directory that will contain the GCC sources.
500 SOURCE_DIRECTORY=""
502 # The directories that should be part of the various language-specific
503 # tar files. These are all relative to the top of the source tree.
504 ADA_DIRS="gcc/ada libada"
505 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
506 FORTRAN_DIRS="gcc/f libf2c"
507 FORTRAN95_DIRS="gcc/fortran libgfortran"
508 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
509 OBJECTIVEC_DIRS="gcc/objc libobjc"
510 TESTSUITE_DIRS="gcc/testsuite"
512 # Non-zero if this is the final release, rather than a prerelease.
513 FINAL=0
515 # Non-zero if we are building a snapshot, and don't build gcc or
516 # include generated files.
517 SNAPSHOT=0
519 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
520 # and copy directly to the FTP directory.
521 LOCAL=0
523 # Major operation modes.
524 MODE_GZIP=0
525 MODE_DIFFS=0
526 MODE_SOURCES=0
527 MODE_TARFILES=0
528 MODE_UPLOAD=0
530 # List of archive files generated; used to create .gz files from .bz2.
531 FILE_LIST=""
533 # Programs we use.
535 BZIP2="${BZIP2:-bzip2}"
536 CVS="${CVS:-cvs -f -Q -z9}"
537 DIFF="${DIFF:-diff -Nrcpad}"
538 ENV="${ENV:-env}"
539 GZIP="${GZIP:-gzip --best}"
540 SCP="${SCP:-scp -p}"
541 SSH="${SSH:-ssh}"
542 TAR="${TAR:-tar}"
544 ########################################################################
545 # Command Line Processing
546 ########################################################################
548 # Parse the options.
549 while getopts "d:fr:u:t:p:s:l" ARG; do
550 case $ARG in
551 d) DESTINATION="${OPTARG}";;
552 r) RELEASE="${OPTARG}";;
553 t) TAG="${OPTARG}";;
554 u) CVS_USERNAME="${OPTARG}";;
555 f) FINAL=1;;
556 s) SNAPSHOT=1
557 BRANCH=${OPTARG%:*}
558 CVSBRANCH=${OPTARG#*:}
560 l) LOCAL=1
561 SCP=cp
562 PATH=~:/usr/local/bin:$PATH;;
563 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
564 if [ ! -f ${OPTARG} ]; then
565 error "-p argument must name a tarball"
566 fi;;
567 \?) usage;;
568 esac
569 done
570 shift `expr ${OPTIND} - 1`
572 # Handle the major modes.
573 while [ $# -ne 0 ]; do
574 case $1 in
575 diffs) MODE_DIFFS=1;;
576 gzip) MODE_GZIP=1;;
577 sources) MODE_SOURCES=1;;
578 tarfiles) MODE_TARFILES=1;;
579 upload) MODE_UPLOAD=1;;
580 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
581 if [ $SNAPSHOT -ne 1 ]; then
582 # Only for releases and pre-releases.
583 MODE_GZIP=1;
586 *) error "Unknown mode $1";;
587 esac
588 shift
589 done
591 # Perform consistency checking.
592 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
593 error "No username specified"
596 if [ ! -d ${DESTINATION} ]; then
597 error "\`${DESTINATION}' is not a directory"
600 if [ $SNAPSHOT -eq 0 ]; then
601 if [ -z ${RELEASE} ]; then
602 error "No release number specified"
605 # Compute the major and minor release numbers.
606 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
607 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
608 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
610 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
611 error "Release number \`${RELEASE}' is invalid"
614 # Compute the full name of the release.
615 if [ -z "${RELEASE_REVISION}" ]; then
616 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
617 else
618 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
621 # Compute the name of the branch, which is based solely on the major
622 # and minor release numbers.
623 CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
625 # If this is not a final release, set various parameters acordingly.
626 if [ ${FINAL} -ne 1 ]; then
627 RELEASE="${RELEASE}-${DATE}"
628 FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
629 else
630 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
632 else
633 RELEASE=${BRANCH}-${DATE}
634 FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
635 if [ ${CVSBRANCH} != "HEAD" ]; then
636 TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
639 # If diffs are requested when building locally on gcc.gnu.org, we (usually)
640 # know what the last snapshot date was and take the corresponding tarballs,
641 # unless the user specified tarballs explictly.
642 if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ] && [ -z "${OLD_TARS}" ]; then
643 LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
644 OLD_TARS=${SNAPSHOTS_DIR}/${BRANCH}-${LAST_DATE}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
648 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
649 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
650 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
652 # Recompute the names of all the language-specific directories,
653 # relative to the WORKING_DIRECTORY.
654 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
655 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
656 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
657 FORTRAN95_DIRS=`adjust_dirs ${FORTRAN95_DIRS}`
658 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
659 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
660 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
662 # Set up CVSROOT.
663 if [ $LOCAL -eq 0 ]; then
664 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
665 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
666 else
667 CVSROOT="${CVS_REPOSITORY}"
669 export CVSROOT
671 ########################################################################
672 # Main Program
673 ########################################################################
675 # Set the timezone to UTC
676 TZ="UTC0"
677 export TZ
679 # Build the source directory.
681 if [ $MODE_SOURCES -ne 0 ]; then
682 build_sources
685 # Build the tar files.
687 if [ $MODE_TARFILES -ne 0 ]; then
688 build_tarfiles
691 # Build diffs
693 if [ $MODE_DIFFS -ne 0 ]; then
694 # Possibly build diffs.
695 if [ -n "$OLD_TARS" ]; then
696 for old_tar in $OLD_TARS; do
697 build_diffs $old_tar
698 done
702 # Build gzip files
703 if [ $MODE_GZIP -ne 0 ]; then
704 build_gzip
707 # Upload them to the FTP server.
709 if [ $MODE_UPLOAD -ne 0 ]; then
710 upload_files
712 # For snapshots, make some further updates.
713 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
714 announce_snapshot
716 # Update snapshot date file.
717 changedir ~
718 echo $DATE > .snapshot_date-${BRANCH}
720 # Remove working directory
721 rm -rf ${WORKING_DIRECTORY}